// Copyright (c) 2010 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// A generic onclick callback function.
function genericOnClick(info, tab) {
    // console.log("item " + info.menuItemId + " was clicked");
    // console.log("info: " + JSON.stringify(info));
    // console.log("tab: " + JSON.stringify(tab));
}

// Create one test item for each context type.
// var contexts = ["page", "selection", "link", "editable", "image", "video",
//     "audio"
// ];
// for (var i = 0; i < contexts.length; i++) {
//   var context = contexts[i];
//   var title = "Test '" + context + "' menu item";
//   var id = chrome.contextMenus.create({"title": title, "contexts":[context],
//                                        "onclick": genericOnClick});
//   console.log("'" + context + "' item:" + id);
// }

function processfile(imageURL, callback) {
    var image = new Image();
    var onload = function () {
        var canvas = document.createElement("canvas");
        canvas.width =this.width;
        canvas.height =this.height;

        var ctx = canvas.getContext("2d");
        ctx.drawImage(this, 0, 0);

        canvas.toBlob(function(blob) {
            // do stuff with blob
            callback(blob);
        });
    };

    image.onload = onload;
    image.src = imageURL;
}

document.addEventListener("contextmenu", function (e) {
    var elem = e.srcElement;
    if (elem instanceof HTMLImageElement) {
        var img = {
            src: elem.src,
            alt: elem.alt,
            height: elem.height,
            width: elem.width
        }
        chrome.extension.sendRequest(img);
    }
}, true);

chrome.contextMenus.create({
    title: "Save Image to Eagle",
    contexts: ["image"],
    onclick: function (info, tab) {
        window.jQuery.ajax({
            type: "POST",
            url: "http://localhost:41593",
            dataType: "json",
            timeout: 3000,
            data: {
                type: "image",
                title: tab.title.replace(/[@#$%^&*()<>:'"\/\\|?*]+/g, ''),
                url: tab.url,
                src: info.srcUrl
            }
        }).always(function (result) {
            if (result.status == 0) {
                openEagle();
            }
        })
    }
});

function openEagle () {
    chrome.tabs.query({active: true, currentWindow: true}, function(tabs) {
        chrome.tabs.sendMessage(tabs[0].id, { action: "open-not-opened-modal" }, function(response) {});
    });
};